Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.list
Class PredicatedList

    java.lang.Object
      org.apache.commons.collections.collection.AbstractCollectionDecorator
          org.apache.commons.collections.collection.AbstractSerializableCollectionDecorator
              org.apache.commons.collections.collection.PredicatedCollection
                  org.apache.commons.collections.list.PredicatedList

All Implemented Interfaces:
  java.io.Serializable, java.lang.Iterable, java.util.Collection, java.util.List

    public class PredicatedList

extends PredicatedCollection
implements java.util.List

Decorates another `List` to validate that all additions match a specified predicate.

This list exists to provide validation for the decorated list. It is normally created to decorate an empty list. If an object cannot be added to the list, an IllegalArgumentException is thrown.

One usage would be to ensure that no null entries are added to the list.

    List list = PredicatedList.decorate(new ArrayList(), NotNullPredicate.INSTANCE);

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Nested Class Summary
`protected class` | `PredicatedList.PredicatedListIterator` Inner class Iterator for the PredicatedList

Field Summary

Fields inherited from class org.apache.commons.collections.collection.PredicatedCollection
`predicate`

Fields inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`collection`

Constructor Summary
`protected` | `PredicatedList(java.util.List list, Predicate predicate)` Constructor that wraps (not copies).

Method Summary
`void` | `add(int index, java.lang.Object object)`
`boolean` | `addAll(int index, java.util.Collection coll)`
`static java.util.List` | `decorate(java.util.List list, Predicate predicate)` Factory method to create a predicated (validating) list.
`java.lang.Object` | `get(int index)`
`protected java.util.List` | `getList()` Gets the list being decorated.
`int` | `indexOf(java.lang.Object object)`
`int` | `lastIndexOf(java.lang.Object object)`
`java.util.ListIterator` | `listIterator()`
`java.util.ListIterator` | `listIterator(int i)`
`java.lang.Object` | `remove(int index)`
`java.lang.Object` | `set(int index, java.lang.Object object)`
`java.util.List` | `subList(int fromIndex, int toIndex)`

Methods inherited from class org.apache.commons.collections.collection.PredicatedCollection
`add, addAll, decorate, validate`

Methods inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`clear, contains, containsAll, equals, getCollection, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.List
`add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

Constructor Detail

### PredicatedList

    protected PredicatedList(java.util.List list,
                             Predicate predicate)

  Constructor that wraps (not copies).

  If there are any elements already in the list being decorated, they are validated.

  Parameters:
    `list` - the list to decorate, must not be null
    `predicate` - the predicate to use for validation, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if list or predicate is null
    `java.lang.IllegalArgumentException` - if the list contains invalid elements

Method Detail

### decorate

    public static java.util.List decorate(java.util.List list,
                                          Predicate predicate)

  Factory method to create a predicated (validating) list.

  If there are any elements already in the list being decorated, they are validated.

  Parameters:
    `list` - the list to decorate, must not be null
    `predicate` - the predicate to use for validation, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if list or predicate is null
    `java.lang.IllegalArgumentException` - if the list contains invalid elements

### getList

    protected java.util.List getList()

  Gets the list being decorated.

  Returns:
    the decorated list

### get

    public java.lang.Object get(int index)

  Specified by:
    `get` in interface `java.util.List`

### indexOf

    public int indexOf(java.lang.Object object)

  Specified by:
    `indexOf` in interface `java.util.List`

### lastIndexOf

    public int lastIndexOf(java.lang.Object object)

  Specified by:
    `lastIndexOf` in interface `java.util.List`

### remove

    public java.lang.Object remove(int index)

  Specified by:
    `remove` in interface `java.util.List`

### add

    public void add(int index,
                    java.lang.Object object)

  Specified by:
    `add` in interface `java.util.List`

### addAll

    public boolean addAll(int index,
                          java.util.Collection coll)

  Specified by:
    `addAll` in interface `java.util.List`

### listIterator

    public java.util.ListIterator listIterator()

  Specified by:
    `listIterator` in interface `java.util.List`

### listIterator

    public java.util.ListIterator listIterator(int i)

  Specified by:
    `listIterator` in interface `java.util.List`

### set

    public java.lang.Object set(int index,
                                java.lang.Object object)

  Specified by:
    `set` in interface `java.util.List`

### subList

    public java.util.List subList(int fromIndex,
                                  int toIndex)

  Specified by:
    `subList` in interface `java.util.List`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.